unit Besttime;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls;

type
  TBestTimeDlg = class(TForm)
    OKBtn: TButton;
    Bevel1: TBevel;
    Reinit: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ReinitClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type score = record
             Name : String[15];
             Time : Word;
             end;

var
  BestTimeDlg : TBestTimeDlg;
  ABest       : array[1..3] of Score;
  F           : textFile;
  ch          : String[1];

implementation

uses reuss;
{$R *.DFM}

procedure TBestTimeDlg.FormCreate(Sender: TObject);
          var i, j : Byte;
          begin
               for i := 1 to  3 do ABest[i].Name := 'Joe La Fiote__';
               for i := 1 to  3 do ABest[i].Time := 600;
               {$I-}
               assignFile(F, 'BestTime');
               FileMode := 0;
               Reset(F);
               if (IOResult = 0) then
                 for i := 1 to 3 do
                   begin
                     readln(F, ABest[i].Name, ABest[i].Time);
                     j := 0;
                     repeat inc(j) until (ABest[i].Name[j] <> ' ');
                     ABest[i].Name := copy(ABest[i].Name, j, length(ABest[i].Name) - j + 1);
                   end;
               CloseFile(F);
               {$I+}
               if Winner then
                 begin
                   i := 1;
                   while ((ABest[i].Time < Time) and (i < 5)) do inc(i);
                   if (i > 3) then exit;
                   case i of
                        1 : begin
                              ABest[3].Name  := ABest[2].Name;
                              ABest[2].Name  := ABest[1].Name;
                              ABest[1].Name  := '';
                              ABest[3].Time  := ABest[2].Time;
                              ABest[2].Time  := ABest[1].Time;
                              Edit1.ReadOnly := False;
                              ABest[1].Time  := Time;
                              ActiveControl  := Edit1;
                            end;
                        2 : begin
                              ABest[3].Name  := ABest[2].Name;
                              ABest[2].Name  := '';
                              ABest[3].Time  := ABest[2].Time;
                              Edit2.ReadOnly := False;
                              ABest[2].Time  := Time;
                              ActiveControl  := Edit2;
                            end;
                        3 : begin
                              ABest[3].Name  := '';
                              Edit3.ReadOnly := False;
                              ABest[3].Time  := Time;
                              ActiveControl  := Edit3;
                            end;
                        end;
                  end;
               Edit1.Text     := ABest[1].Name;
               Edit2.Text     := ABest[2].Name;
               Edit3.Text     := ABest[3].Name;
               if (ABest[1].time mod 60 < 10) then ch := '0'
               else ch := '';
               Label4.Caption := inttostr(ABest[1].time div 60) + ' : ' + ch + inttostr(ABest[1].time mod 60);
               if (ABest[2].time mod 60 < 10) then ch := '0'
               else ch := '';
               Label5.Caption := inttostr(ABest[2].time div 60) + ' : ' + ch + inttostr(ABest[2].time mod 60);
               if (ABest[3].time mod 60 < 10) then ch := '0'
               else ch := '';
               Label6.Caption := inttostr(ABest[3].time div 60) + ' : ' + ch + inttostr(ABest[3].time mod 60);
          end;

procedure TBestTimeDlg.FormClose(Sender: TObject;
          var Action: TCloseAction);
          var i : Byte;
          begin
               ABest[1].Name := Edit1.Text;
               ABest[2].Name := Edit2.Text;
               ABest[3].Name := Edit3.Text;
               {$I-}
               AssignFile(F, 'BestTime');
               FileMode := 1;
               reWrite(F);
               for i := 1 to 3 do Writeln(F, ABest[i].Name:15, ABest[i].Time:3);
               CloseFile(F);
               {$I+}
          end;

procedure TBestTimeDlg.ReinitClick(Sender: TObject);
          var i : Byte;
          begin
               for i := 1 to  3 do ABest[i].Name := 'Joe La Fiote';
               for i := 1 to  3 do ABest[i].Time := 600;
               Edit1.Text     := ABest[1].Name;
               Edit2.Text     := ABest[2].Name;
               Edit3.Text     := ABest[3].Name;
               if (ABest[1].time mod 60 < 10) then ch := '0'
               else ch := '';
               Label4.Caption := inttostr(ABest[1].time div 60) + ' : ' + ch + inttostr(ABest[1].time mod 60);
               if (ABest[2].time mod 60 < 10) then ch := '0'
               else ch := '';
               Label5.Caption := inttostr(ABest[2].time div 60) + ' : ' + ch + inttostr(ABest[2].time mod 60);
               if (ABest[3].time mod 60 < 10) then ch := '0'
               else ch := '';
               Label6.Caption := inttostr(ABest[3].time div 60) + ' : ' + ch + inttostr(ABest[3].time mod 60);
          end;

end.

