unit reuss;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ExtCtrls, Menus, Regles, LeJeu, BestTime, APropos, ImgList;

type
  TForm1 = class(TForm)
    B_habit: TSpeedButton;
    B_nom: TSpeedButton;
    B_fam: TSpeedButton;
    B_donne: TSpeedButton;
    B_vierge: TSpeedButton;
    B_back: TSpeedButton;
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Donne1: TMenuItem;
    N1: TMenuItem;
    Quitter1: TMenuItem;
    Aide1: TMenuItem;
    Alaide1: TMenuItem;
    N2: TMenuItem;
    APropos1: TMenuItem;
    Image: TImage;
    Annuler1: TMenuItem;
    Timer1: TTimer;
    N3: TMenuItem;
    MeilleursTemps1: TMenuItem;
    ImageLst: TImageList;
    LeJeu1: TMenuItem;
    Image1: TImage;
    procedure Donne;
    procedure drawcarte(x, y, carte : integer);
    procedure B_backClick(Sender: TObject);
    procedure B_DonneClick(Sender: TObject);
    procedure ImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure APropos1Click(Sender: TObject);
    procedure Alaide1Click(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure Donne1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Annuler1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure MeilleursTemps1Click(Sender: TObject);
    procedure LeJeu1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type carte = record
                   num : byte;
                   x1  : word;
                   x2  : word;
                   y1  : word;
                   y2  : word;
                   etat: byte;
                   xtab: byte;
                   ytab: byte;
                   rgb : byte;
             end;

var
  Form1      : TForm1;
  img1       : Tbitmap;
  img2       : Tbitmap;
  img3       : Tbitmap;
  img4       : Tbitmap;
  num        : byte;
  fam        : byte;
  carten     : byte;
  carte1     : byte;
  cartetir   : byte;
  cartepaire : byte;
  couple     : byte;
  tirannul   : byte;
  Arrowon    : boolean;
  Donneon    : boolean;
  Dooron     : boolean;
  debut      : boolean;
  Winner     : boolean;
  Time       : word;
  T_jeu      : array[1..52] of boolean;
  T_Htapis   : array[0..12, 0..7] of carte;
  T_Btapis   : array[0..32] of carte;
  T_Face     : array[1..9] of carte;
  T_couple   : array[1..2] of carte;
  T_Annul    : array[1..2] of carte;

const T_num : array[1..13] of string[5] = ('as', '2', '3', '4', '5', '6', '7', '8', '9', '10', 'valet', 'dame', 'roi');      T_fam : array[0..5]  of string[7] = ('0', 'carreau', 'coeur', 'pique', 'trefle', '5');

implementation

{$R *.DFM}


{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
procedure TForm1.FormCreate(Sender: TObject);
          begin
               form1.width  := 640;
               form1.height := 480;
               form1.top    := 0;
               form1.left   := 0;
               color := clgreen;
               Image.canvas.brush.color := clGreen;
               Image.canvas.fillrect(rect(0,0,Image.width, Image.Height));
               ImageLst.Draw(Image.Canvas, 5  , 5, 2);
               ImageLst.Draw(Image.Canvas, 90 , 5, 0);
               ImageLst.Draw(Image.Canvas, 560, 5, 4);
               Form1.B_DonneClick(Sender);
          end;
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
procedure TForm1.DrawCarte(x, y, carte : integer);
          begin
          {s'il faut dessiner la carte de dos}
               if (carte = 0) then Image.canvas.draw(x, y, B_back.glyph);
               if (carte = 0) then exit;
          {determination de num et fam a partir de carte}
               num := carte mod 13;
               fam := carte div 13 + 1;
               if (num = 0) then dec(fam);
               if (num = 0) then num := 13;
          {dessin du contour de la carte}
               Image.canvas.draw(x, y, B_vierge.glyph);
               img1 := B_fam.glyph;
               img2 := B_nom.glyph;
               img3 := B_habit.glyph;
          {dessin des signe fam pour as a 10}
               if (num < 11) then
                  begin
                       if (num > 3) then
                          begin
                               Image.canvas.copyrect(rect(x+17, y+2 , x+30, y+15), img1.canvas, rect(13 * (fam - 1), 0, 13 * fam, 13));
                               Image.canvas.copyrect(rect(x+45, y+2 , x+58, y+15), img1.canvas, rect(13 * (fam - 1), 0, 13 * fam, 13));
                               Image.canvas.copyrect(rect(x+17, y+65, x+30, y+78), img1.canvas, rect(13 * (fam - 1), 0, 13 * fam, 13));
                               Image.canvas.copyrect(rect(x+45, y+65, x+58, y+78), img1.canvas, rect(13 * (fam - 1), 0, 13 * fam, 13));
                          end;
                       if (num > 7) then
                          begin
                               Image.canvas.copyrect(rect(x+17, y+23, x+30, y+36), img1.canvas, rect(13 * (fam - 1), 0, 13 * fam, 13));
                               Image.canvas.copyrect(rect(x+45, y+23, x+58, y+36), img1.canvas, rect(13 * (fam - 1), 0, 13 * fam, 13));
                               Image.canvas.copyrect(rect(x+17, y+44, x+30, y+57), img1.canvas, rect(13 * (fam - 1), 0, 13 * fam, 13));
                               Image.canvas.copyrect(rect(x+45, y+44, x+58, y+57), img1.canvas, rect(13 * (fam - 1), 0, 13 * fam, 13));
                          end;
                       if (num mod 2 = 1) then
                          begin
                               Image.canvas.copyrect(rect(x+31, y+34, x+44, y+47), img1.canvas, rect(13 * (fam - 1), 0, 13 * fam, 13));
                          end;
                       if ((num = 2) or (num = 3) or (num = 6) or (num = 7) or (num = 10)) then
                          begin
                               Image.canvas.copyrect(rect(x+31, y+13, x+44, y+26), img1.canvas, rect(13 * (fam - 1), 0, 13 * fam, 13));
                               Image.canvas.copyrect(rect(x+31, y+54, x+44, y+67), img1.canvas, rect(13 * (fam - 1), 0, 13 * fam, 13));
                          end;
                       if (num = 1) then
                          Image.canvas.copyrect(rect(x+2, y+29, x+58, y+79), img3.canvas, rect(60*fam-58, 150, 60*fam-2, 200));
                  end
          {dessin des habilles}
               else
                  begin
                       Image.canvas.copyrect(rect(x+2, y+29, x+58, y+79), img3.canvas, rect(60*fam-58, 50*(num-11), 60*fam-2, 50*(num-10)));
                  end;
          {dessin du nom et de la famille de la carte}
               Image.canvas.copyrect(rect(x+2, y+2, x+17, y+17), img2.Canvas, rect(16*(num-1), 16*round(fam/4), 16*num-1, 15+16*round(fam/4)));
               Image.canvas.CopyRect(rect(x + 3 , y + 18 , x + 16, y + 31), img1.canvas, rect(13 * (fam - 1), 0, 13 * fam, 13));
          end;
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
procedure FaceRefresh;
          var i,j,tmp : integer;
          begin
               tmp := 1;
               for i := 1 to 9 do T_face[i] := T_Htapis[1,1];
               for i := 1 to 6 do
               for j := 1 to 11 do
                   if ((T_Htapis[j-1,i+1].num = 0) and (T_Htapis[j+1,i+1].num = 0) and (T_Htapis[j,i].num > 0)) then
                      begin
                           T_face[tmp] := T_Htapis[j,i];
                           inc(tmp);
                      end;
               if (carte1 > 0) then
                  begin
                       T_Face[7] := T_Btapis[carte1];
                       if (carten > carte1) then
                          begin
                               T_face[7].x2 := T_face[7].x1 + 16;
                               T_face[9] := T_Btapis[carten];
                          end;
                       if (carten > carte1 + 1) then
                          begin
                               T_face[8] := T_Btapis[carten-1];
                               T_face[8].x2 := T_face[8].x1 + 16;
                          end;
                  end;
          end;
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
procedure Drawrefresh;
          var i, j, jj : integer;
          begin
               for i := 1 to 6 do
               for j := 1 to 11 do
                   begin
                        jj := round((i + j - 5) / 2);
                        if ((T_Htapis[j-1,i+1].num = 0) and (T_Htapis[j+1,i+1].num = 0) and  (T_Htapis[j,i].num > 0)) then
                           begin
                                form1.drawcarte(300 - (i mod 2) * 40 - (i div 2) * 80 + 80 * (jj - 1), 50 * (i - 1) + 5, T_Htapis[j,i].num);
                           end;
                        if (((T_Htapis[j-1,i+1].num > 0) or (T_Htapis[j+1,i+1].num > 0)) and (T_Htapis[j,i].num > 0)) then
                           begin
                                form1.drawcarte(300 - (i mod 2) * 40 - (i div 2) * 80 + 80 * (jj - 1), 50 * (i - 1) + 5, 0);
                           end;
                   end;
               Form1.Image.canvas.fillrect(rect(75,347,form1.width-1,form1.Height-1));
               if (carte1 > 0) then
                   for i := carte1 to carten do form1.drawcarte(80 + 16 * i, 347, T_Btapis[i].num);
          end;
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
{----------------------------------------------------------------------------------------------------------------------}
procedure destruction(det : carte);
          begin
               Form1.Image.Canvas.Draw(450 + random(40), 5 + random(35), Form1.B_back.glyph);
               if (det.rgb > 0) then
                  begin
                       T_Btapis[det.rgb] := T_Htapis[1,1];
                       form1.Image.Canvas.fillrect(rect(det.x1, det.y1, det.x2, det.y2));
                       exit;
                  end;
               if (det.xtab > 0) then
                  begin
                       T_Htapis[det.xtab,det.ytab].num := 0;
                       form1.Image.Canvas.fillrect(rect(det.x1, det.y1, det.x2, det.y2));
                       exit;
                  end;
          end;
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
procedure TForm1.B_backClick(Sender: TObject);
          var cmpt : integer;
          begin
               couple := 0;
               Drawrefresh;
               if ((carten > 30) or (cartetir >= 31)) then exit;
               cmpt := 0;
               T_Annul[1].xtab := 0;
               T_Annul[1].rgb  := 0;
               repeat
                     num := random(52) + 1;
                     inc(cmpt);
                     if (cmpt > 100000) then break;
               until (T_jeu[num] = false);
               if (cmpt > 100000) then image.canvas.Fillrect(rect(8,345,70,427));
               if (cmpt > 100000) then exit;
               if (tirannul > 0) then num := tirannul;
               if (tirannul > 0) then tirannul := 0;
               T_jeu[num] := true;
               inc(carten);
               inc(cartetir);
               T_Btapis[carten].num := num;
               T_Btapis[carten].x1  := 80  + carten * 16;
               T_Btapis[carten].y1  := 347;
               T_Btapis[carten].x2  := 140 + carten * 16;
               T_Btapis[carten].y2  := 427;
               T_Btapis[carten].rgb := carten;
               drawcarte(80 + carten * 16, 347, num);
               if (carte1 = 0)  then carte1 := 1;
               if (cartetir >= 31) then image.canvas.Fillrect(rect(8,345,70,427));
               Image.canvas.TextOut(10, 326, inttostr(31 - cartetir) + ' cartes  ');
               FaceRefresh;
          end;
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
procedure TForm1.Donne;
          var i, j : integer;
          begin
               randomize;
               for i := 1 to 52 do T_jeu[i] := false;
               for i := 1 to 9  do T_face[i] := T_Htapis[1,1];
               for i := 0 to 32 do T_Btapis[i].num := 0;
               carte1     := 0;
               time       := 0;
               carten     := 0;
               cartetir   := 0;
               cartepaire := 0;
               Arrowon    := false;
               Donneon    := false;
               couple     := 0;
               Tirannul   := 0;
               T_annul[1] := T_Htapis[1,1];
               T_annul[2] := T_Htapis[1,1];
               Timer1.Enabled := false;
               Image.canvas.FillRect(Rect(185,20,240,40));
               Image.canvas.brush.color := clgreen;
               Image.canvas.fillrect(rect(75,347,form1.width-1,form1.Height-1));
               Image.canvas.fillrect(rect(450,5,550,120));
               Image.canvas.TextOut(10, 326, '31 cartes');
               Image.Canvas.Draw(8,345,B_back.glyph);
               Image.Canvas.Draw(10,347,B_back.glyph);
               T_Htapis[1,1].num  := 0;
               T_Htapis[1,1].xtab := 0;
               T_Htapis[1,1].ytab := 0;
               T_Htapis[1,1].rgb  := 0;
               T_Htapis[1,1].x1   := 0;
               T_Htapis[1,1].x2   := 0;
               T_Htapis[1,1].y1   := 0;
               T_Htapis[1,1].y2   := 0;
               for i := 1 to 6 do
               for j := 1 to i do
                   begin
                        repeat
                              num := random(52) + 1;
                        until (T_jeu[num] = false);
                        T_jeu[num] := true;
                        T_Htapis[2 * j + 5 - i, i].x1   := 300 - (i mod 2) * 40 - (i div 2) * 80 + 80 * (j - 1);
                        T_Htapis[2 * j + 5 - i, i].y1   := 50 * (i - 1) + 5;
                        T_Htapis[2 * j + 5 - i, i].x2   := 300 - (i mod 2) * 40 - (i div 2) * 80 + 80 * (j - 1) + 60;
                        T_Htapis[2 * j + 5 - i, i].y2   := 50 * (i - 1) + 5 + 80;
                        T_Htapis[2 * j + 5 - i, i].xtab := 2 * j + 5 - i;
                        T_Htapis[2 * j + 5 - i, i].ytab := i;
                        T_Htapis[2 * j + 5 - i, i].num  := num;
                        T_Htapis[2 * j + 5 - i, i].etat := 0;
                        if (i = 6) then
                           begin
                                T_face[j] := T_Htapis[2 * j + 5 - i, i];
                                drawcarte(300 - (i mod 2) * 40 - (i div 2) * 80 + 80 * (j - 1), 50 * (i - 1) + 5, num);
                           end
                        else
                           drawcarte(300 - (i mod 2) * 40 - (i div 2) * 80 + 80 * (j - 1), 50 * (i - 1) + 5, 0);
                   end;

          end;
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
procedure TForm1.B_DonneClick(Sender: TObject);
          begin
               Donne;
          end;
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
procedure TForm1.ImageMouseDown(Sender: TObject; Button: TMouseButton;
                               Shift: TShiftState; X, Y: Integer);
          var i, j : integer;
          {fonction de detection de la zone de click}
          function clickon(x1, y1, x2, y2 : word) : boolean;
                   begin
                        result := ((x >= x1) and (x <= x2) and (y >= y1) and(y <= y2));
                   end;
          begin
               timer1.enabled := true;
          {est-ce qu'on a cliquer sur un endroit 'cliquable'}
               for i := 1 to 9 do
               if clickon(T_face[i].x1, T_face[i].y1, T_face[i].x2, T_face[i].y2) then
                  begin
                       inc(couple);
                       T_couple[couple] := T_face[i];
                       Image.canvas.copyrect(rect(0,50,T_couple[couple].x2 - T_couple[couple].x1,130), Image.canvas, rect(T_couple[couple].x1, T_couple[couple].y1, T_couple[couple].x2, T_couple[couple].y2));
                       Image.canvas.copymode := cmnotsrccopy;
                       Image.canvas.copyrect(rect(T_couple[couple].x1, T_couple[couple].y1, T_couple[couple].x2, T_couple[couple].y2), Image.canvas, rect(0,50,T_couple[couple].x2 - T_couple[couple].x1,130));
                       Image.canvas.copymode := cmsrccopy;
                       Image.canvas.fillrect(rect(0,50,60,130));
                  end;
          {click sur 'donne'}
               if clickon(5,5,90,65) then Form1.B_DonneClick(sender);
          {click sur 'annuler'}
               if clickon(90,5,175,65) then Annuler1Click(Sender);
          {click sur 'quitter'}
               if clickon(560,5,610,65) then Quitter1Click(Sender);
          {click sur la pioche}
               if clickon(8,345,70,427) then Form1.B_BackClick(sender);
          {gestion des couples de cartes}
          {couple avant-derniere carte piochee/carte<>derniere carte piochee}
               if (((T_couple[1].rgb = carten-1) and (T_Couple[2].rgb <> carten) and (carten > carte1+1) and (couple = 2))
               or  ((T_couple[2].rgb = carten-1) and (T_Couple[1].rgb <> carten) and (carten > carte1+1) and (couple = 2))) then
                  begin
                       couple := 0;
                       T_couple[1] := T_Htapis[1,1];
                       T_couple[2] := T_Htapis[1,1];
                       DrawRefresh;
                  end;
          {couple valide}
               if ((couple >= 2) and ((T_couple[1].num mod 13) + (T_couple[2].num mod 13) = 13)) then
                  begin
                       T_Annul[1] := T_couple[1];     T_Annul[2] := T_couple[2];
                       destruction(T_couple[1]);      destruction(T_couple[2]);
                       T_couple[1] := T_Htapis[1,1];  T_couple[2] := T_Htapis[1,1];
                       inc(cartepaire, 2);
                       if (carte1 > 0) then
                          begin
                               i := 0; repeat inc(i) until (T_Btapis[i].num > 0);
                               j := i; repeat inc(j) until (T_Btapis[j].num = 0);
                               if ((i < 32) and (i > 0)) then begin
                                       carte1 := i; carten := j - 1; end
                               else begin
                                       carte1 := 0; carten := 0;     end;
                          end;
                       DrawRefresh;
                       couple := 0;
                  end;
          {couple invalide}
               if (couple >= 2) then
                  begin
                       T_couple[1] := T_Htapis[1,1];  T_couple[2] := T_Htapis[1,1];
                       DrawRefresh; couple := 0;
                  end;
          {un roi tout seul ?}
               if ((couple >= 1) and (T_couple[1].num mod 13 = 0)) then
                  begin
                       T_Annul[1] := T_couple[1]; T_Annul[2] := T_couple[1];
                       destruction(T_couple[1]);  inc(cartepaire);
                       if (carte1 > 0) then
                          begin
                               i := 0; repeat inc(i) until (T_Btapis[i].num > 0);
                               j := i; repeat inc(j) until (T_Btapis[j].num = 0);
                               if ((i < 32) and (i > 0)) then begin
                                       carte1 := i; carten := j - 1; end
                               else begin
                                       carte1 := 0; carten := 0;     end;
                          end;
                       T_couple[1] := T_Htapis[1,1];
                       DrawRefresh; couple := 0;
                  end;
               FaceRefresh;
          {le jeu est fini ?}
               if (cartepaire >= 52) then
                  begin
                       Timer1.Enabled := false;
                       Winner := True;
                       with TBestTimeDlg.Create(Self) do
                         try
                           ShowModal;
                         finally
                           Free;
                       end;
                       Winner := False;
                  end;
          end;
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
procedure TForm1.APropos1Click(Sender: TObject);
          begin
               with TAProposDlg.Create(Self) do
                 try
                    ShowModal;
                 finally
                    Free;
               end;
          end;
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
procedure TForm1.Alaide1Click(Sender: TObject);
          begin
               with TReglesDlg.Create(Self) do
                 try
                    ShowModal;
                 finally
                    Free;
               end;
          end;
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
procedure TForm1.Quitter1Click(Sender: TObject);
          begin
               close;
          end;
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
procedure TForm1.Donne1Click(Sender: TObject);
          begin
               B_DonneClick(sender);
          end;
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
procedure TForm1.ImageMouseMove(Sender: TObject; Shift: TShiftState; X,
          Y: Integer);
          function clickon(x1, y1, x2, y2 : word) : boolean;
                   begin
                        result := ((x > x1) and (x < x2) and (y > y1) and (y < y2));
                   end;
          begin
               if (clickon(5,5,90,65) and not(donneon)) then
                  begin
                       ImageLst.Draw(Image.Canvas, 5 , 5, 3);
                       Image.canvas.TextOut(30, 60, 'Donne');
                       donneon := true;
                  end;
               if (not(clickon(5,5,90,65)) and donneon) then
                  begin
                       ImageLst.Draw(Image.Canvas, 5 , 5, 2);
                       Image.Canvas.FillRect(Rect(30,60,63,71));
                       donneon := false;
                  end;
               if (clickon(90,5,175,65) and not(arrowon)) then
                  begin
                       ImageLst.Draw(Image.Canvas, 90, 5, 1);
                       Image.canvas.TextOut(100, 60, 'Annuler');
                       arrowon := true;
                  end;
               if (not(clickon(90,5,175,65)) and arrowon) then
                  begin
                       ImageLst.Draw(Image.Canvas, 90, 5, 0);
                       Image.Canvas.FillRect(Rect(100,60,150,71));
                       arrowon := false;
                  end;
               if (clickon(560,5,610,65) and not(dooron)) then
                  begin
                       ImageLst.Draw(Image.Canvas, 560, 5, 5);
                       Image.canvas.TextOut(570, 70, 'Quitter');
                       dooron := true;
                  end;
               if (not(clickon(560,5,610,65)) and dooron) then
                  begin
                       ImageLst.Draw(Image.Canvas, 560, 5, 4);
                       Image.Canvas.FillRect(Rect(570,70,610,81));
                       dooron := false;
                  end;
          end;
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
procedure TForm1.Annuler1Click(Sender: TObject);
          var i, j : byte;
          begin
               if ((couple = 0) and((T_Annul[1].rgb  > 0) or (T_Annul[1].xtab  > 0))) then
                  begin
                       if (T_Annul[1].rgb  > 0) then T_Btapis[T_Annul[1].rgb] := T_Annul[1];
                       if (T_Annul[1].xtab > 0) Then T_Htapis[T_Annul[1].xtab,T_Annul[1].ytab] := T_Annul[1];
                       if (T_Annul[2].rgb  > 0) then T_Btapis[T_Annul[2].rgb] := T_Annul[2];
                       if (T_Annul[2].xtab > 0) Then T_Htapis[T_Annul[2].xtab,T_Annul[2].ytab] := T_Annul[2];
                  end;
               if ((T_annul[1].xtab = 0) and (T_annul[1].rgb = 0) and (cartetir > 0)) then
                  begin
                       T_jeu[T_Btapis[carten].num] := false;
                       tirannul := T_Btapis[carten].num;
                       destruction(T_Btapis[carten]);
                       dec(cartetir);
                       Image.canvas.TextOut(10, 326, inttostr(31 - cartetir) + ' cartes  ');
                  end;
               i := 0;
               repeat inc(i) until (T_Btapis[i].num > 0);
               j := i;
               repeat inc(j) until (T_Btapis[j].num = 0);
               if ((i < 32) and (i > 0)) then
                  begin
                       carte1 := i;
                       carten := j - 1;
                  end
               else
                  begin
                       carte1 := 0;
                       carten := 0;
                  end;
               if (couple = 1) then
                  begin
                       couple := 0;
                       T_couple[1] := T_Htapis[1,1];
                  end;
               T_face[9] := T_Btapis[carten];
               FaceRefresh;
               DrawRefresh;
               exit;
          end;
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
procedure TForm1.Timer1Timer(Sender: TObject);
          var ch : string[1];
          begin
               inc(time);
               if (time mod 60 < 10) then ch := '0'
               else ch := '';
               Image.canvas.FillRect(Rect(185,20,240,40));
               Image.Canvas.Font.Size := 15;
               Image.canvas.TextOut(185,20,inttostr(time div 60) + ' : ' + ch + inttostr(time mod 60));
               Image.Canvas.font.size := 8;
          end;
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
procedure TForm1.MeilleursTemps1Click(Sender: TObject);
          begin
               Timer1.Enabled := false;
               with TBestTimeDlg.Create(Self) do
                 try
                    ShowModal;
                 finally
                    Free;
               end;
          end;
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
{-----------------------------------------------------------------------------------------------------------------------}
procedure TForm1.LeJeu1Click(Sender: TObject);
          begin
               with TLejeuDlg.Create(Self) do
                 try
                    ShowModal;
                 finally
                    Free;
               end;
          end;

end.
